/**
* [1] Two Sum
 */
#include <bits/stdc++.h>
#include <gtest/gtest.h>
using namespace std;


// submission codes start here

class Solution
{
public:
    vector<int> twoSum(vector<int> &nums, int target)
    {
        unordered_map<int, int> map;

        for (int i = 0; i < nums.size(); ++i)
        {
            if (const auto &it = map.find(target - nums[i]); it != map.end())
            {
                return {it->second, i};
            }

            map.insert({nums[i], i});
        }

        return {};
    }
};

// submission codes endo

TEST(P1, Test1)
{
    Solution s;
    vector nums   = {2, 7, 11, 15};
    vector result = {0, 1};
    ASSERT_EQ(s.twoSum(nums, 9), result);
}